//+------------------------------------------------------------------+
//| ASCTrend1sig_noSound.mq4 
//| Ramdass - Conversion only
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  Yellow

//---- input parameters
extern int  RISK      = 3;
extern int  NoPeriods = 300;
extern bool SoundON   = true;

// original source: 11 + 1
#define OFFSET 12 

bool TurnedUp   = false;
bool TurnedDown = false;  

//---- buffers
double sellSignal[];
double buySignal[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   IndicatorBuffers(2);
   
   SetIndexStyle (0, DRAW_ARROW);
   SetIndexArrow (0, SYMBOL_ARROWDOWN);
   SetIndexBuffer(0, sellSignal);
   
   SetIndexStyle (1, DRAW_ARROW);
   SetIndexArrow (1, SYMBOL_ARROWUP);
   SetIndexBuffer(1, buySignal);

//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| ASCTrend1sig                                                     |
//+------------------------------------------------------------------+
int start() {
   if (NoPeriods >= 1000) {
      NoPeriods = 950;
   }
      
   SetIndexDrawBegin(0, Bars - NoPeriods + OFFSET);
   SetIndexDrawBegin(1, Bars - NoPeriods + OFFSET);
   
   int shift,
       counted_bars = IndicatorCounted();
       
   int defaultPeriods,
       periods;
       
   double inverseWPR,
          signal,          
          upperBound,
          lowerBound;
          
   double TrueCount,
          Range,
          AvgRange,
          MRO1,
          MRO2;
          
   double inverseWPRs[1000];
   
   defaultPeriods = 3 + RISK * 2;
   periods = defaultPeriods;
   
   upperBound      = 67 + RISK;
   lowerBound      = 33 - RISK;
   
   if(Bars <= OFFSET) {
      return(0);
   }
   
   initializeOutputs(NoPeriods, counted_bars);   

   shift = NoPeriods - OFFSET;
   
   while(shift >= 0) {
      int i     = shift;
      Range     = 0.0;
      AvgRange  = 0.0;
      
      for (i = shift; i <= shift + 9; i++) {
         AvgRange = AvgRange + MathAbs(High[i] - Low[i]);
      }
      
      Range     = AvgRange / 10;
      i         = shift;
      TrueCount = 0;
      
      while (i < shift + 9 && TrueCount < 1) {
         if (MathAbs(Open[i] - Close[i + 1]) >= Range * 2.0) {
            TrueCount++;
         }
        
         i++;
      }
      
      if (TrueCount >= 1) {
         MRO1 = i;
      } else {
         MRO1 = -1;
      }
      
      i = shift;
      TrueCount = 0;
      
      while (i < shift + 6 && TrueCount < 1) {
         if (MathAbs(Close[i + 3] - Close[i]) >= Range * 4.6) {
            TrueCount = TrueCount+1;
         }
        
         i++;
      }
         
      if (TrueCount >= 1) {
         MRO2 = i;
      } else {
         MRO2 = -1;
      }
      
      if (MRO1 > -1) {
         periods = 3;
      } else {
         periods = defaultPeriods;
      }
      
      if (MRO2 > -1) {
         periods = 4;
      } else {
         periods = defaultPeriods;
      }
      
      inverseWPR = 100 - MathAbs(iWPR(NULL, 0, periods, shift)); // PercentR(periods = 9)
      
      inverseWPRs[shift]  = inverseWPR;
      sellSignal[shift]   = 0;
      buySignal[shift]    = 0;
      signal              = 0;
      
      int j;
      
      if (inverseWPR < lowerBound) {
        j = 1;
        
        while (inverseWPRs[shift + j] >= lowerBound && inverseWPRs[shift + j] <= upperBound) {
          j++;
        }
        
        if (inverseWPRs[shift + j] > upperBound) {
           signal            = High[shift] + Range * 0.5;
           sellSignal[shift] = signal;
  
           if (shift == 0 && SoundON == true && !TurnedUp) {
              Alert("Sell signal at ", Symbol(), "-", Period());
              
              TurnedUp   = true;
              TurnedDown = false;
           }
           
           Comment("High sellSignal= ",    sellSignal[shift],
                   " | buySignal= ",       buySignal[shift],
                   " | inverseWPR= ",      inverseWPR,
                   " | signal= ",          signal,
                   " | shift= ",           shift);
        } 
      }
         
      if (inverseWPR > upperBound) {
         j = 1;
         
         while (inverseWPRs[shift + j] >= lowerBound && inverseWPRs[shift + j] <= upperBound) {
            j++;
         }
         
         if (inverseWPRs[shift + j] < lowerBound) {
            signal           = Low[shift] - Range * 0.5;
            buySignal[shift] = signal;
            
            if (shift == 0 && SoundON == true && !TurnedDown) {
               Alert("Buy signal at ", Symbol(), "-" , Period());
               
               TurnedDown = true;
               TurnedUp   = false;
         }
         
         Comment("Low sellSignal=", sellSignal[shift], 
                 " | buySignal=",      buySignal[shift], 
                 " | inverseWPR=",     inverseWPR, 
                 " | signal=",         signal, 
                 " | shift=",          shift);
         }
      }

      shift--;
   } // end while(shift >= 0)

   return(0);
}

void initializeOutputs(int NoPeriods, int counted_bars) {
   int i;

   if(counted_bars < OFFSET) {
      for(i = 1; i <=0 ; i++) {
         sellSignal[NoPeriods - i] = 0.0;
      }
      
      for(i = 1; i <= 0; i++) {
         buySignal[NoPeriods - i]  = 0.0;
      }
   }
}

//+------------------------------------------------------------------+


